%bcond_with bootstrap
%global gem_name excon
Name:                rubygem-%{gem_name}
Version:             0.62.0
Release:             3
Summary:             Speed, persistence, http(s)
License:             MIT
URL:                 https://github.com/excon/excon
Source0:             https://rubygems.org/gems/%{gem_name}-%{version}.gem
Patch0:              rubygem-excon-0.62.0-Ruby-2.6-escapes-InvalidURIError-output.patch
Patch1:              CVE-2019-16779.patch
BuildRequires:       ruby(release) rubygems-devel ruby %{_bindir}/openssl rubygem-rack
BuildRequires:       rubygem-shindo rubygem(activesupport) rubygem(delorean) rubygem(eventmachine)
BuildRequires:       rubygem(open4) rubygem(puma) rubygem(sinatra) rubygem(rspec)
BuildArch:           noarch
%description
EXtended http(s) CONnections.

%package help
Summary:             Documentation for %{name}
Requires:            %{name} = %{version}-%{release}
BuildArch:           noarch
Provides:            %{name}-doc = %{version}-%{release}
Obsoletes:           %{name}-doc < %{version}-%{release}
%description help
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version}
%patch0 -p1
%patch1 -p1
sed -i "/ciphers/ s/'.*'/'PROFILE=SYSTEM'/" lib/excon/constants.rb

%build
gem build ../%{gem_name}-%{version}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/
rm -rf %{buildroot}%{gem_instdir}/data

%if %{with bootstrap}
%check
pushd .%{gem_instdir}
sed -i '/if plugin == :unicorn/ i\  before { skip("until #{plugin} is in Fedora") } if plugin == :unicorn' spec/support/shared_contexts/test_server_context.rb
sed -i '/with_unicorn/ s/^/  pending\n\n/' tests/{basic_tests.rb,proxy_tests.rb}
rspec spec
sed -i "/'bundler\/setup'/ s/^/#/" tests/test_helper.rb
sed -i '/redirecting_with_cookie.ru/,/^  end/ s/^/#/' tests/middlewares/capture_cookies_tests.rb
openssl req -subj '/CN=excon/O=excon' -new -newkey rsa:2048 -sha256 -days 365 -nodes -x509 -keyout tests/data/excon.cert.key -out tests/data/excon.cert.crt
openssl req -subj '/CN=127.0.0.1/O=excon' -new -newkey rsa:2048 -sha256 -days 365 -nodes -x509 -keyout tests/data/127.0.0.1.cert.key -out tests/data/127.0.0.1.cert.crt
shindo
popd
%endif

%files
%dir %{gem_instdir}
%exclude %{gem_instdir}/.*
%license %{gem_instdir}/LICENSE.md
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files help
%doc %{gem_docdir}
%doc %{gem_instdir}/CONTRIBUT*
%{gem_instdir}/Gemfile
%doc %{gem_instdir}/README.md
%{gem_instdir}/Rakefile
%{gem_instdir}/benchmarks
%doc %{gem_instdir}/changelog.txt
%{gem_instdir}/excon.gemspec
%{gem_instdir}/spec
%{gem_instdir}/tests

%changelog
* Mon Nov 1 2021 liwu <liwu13@huawei.com> - 0.62.0-3
- Fix CVE-2019-16779

* Sat Sep 5 2020 liyanan <liyanan32@huawei.com> - 0.62.0-2
- fix build fail

* Sat Aug 22 2020 liyanan <liyanan32@huawei.com> - 0.62.0-1
- package init
